#include <windows.h>
#include <ddraw.h>

#define JMENO_TRIDY_OKNA "VSMIE_DDRAW_TEST"

LPDIRECTDRAW7 lpDD;
LPDIRECTDRAWSURFACE7 lpPrimary, lpBack, lpOffScreen;
HRESULT hr;

LPDIRECTDRAWSURFACE7 CreateSurfaceFromBitmap(LPCSTR fileName)
{
	HBITMAP hbmp;
	BITMAP info;
	LPDIRECTDRAWSURFACE7 lpSurf;
	HDC hdc, hdcBitmap;
	hbmp = (HBITMAP) LoadImage(NULL, fileName, IMAGE_BITMAP,0,0
		,LR_LOADFROMFILE | LR_CREATEDIBSECTION);
	if (hbmp==NULL) return NULL;
	GetObject(hbmp,sizeof(BITMAP), &info);
	DDSURFACEDESC2 ddsd;
	ZeroMemory(&ddsd, sizeof(ddsd));
	ddsd.dwSize = sizeof(ddsd);
	ddsd.dwFlags = DDSD_WIDTH | DDSD_HEIGHT | DDSD_DEPTH |DDSD_CAPS
		|DDSD_CKSRCBLT;
	ddsd.dwWidth = info.bmWidth;
	ddsd.dwHeight = info.bmHeight;
	ddsd.dwDepth = 32;
	ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN;	// DDSCAPS_VIDEOMEMORY;
	// klicova barva, ktera bude povazovana za pruhlednou pri kopirovani odsud
	ddsd.ddckCKSrcBlt.dwColorSpaceHighValue = RGB(0,0,0);	// cerna pruhledna
	ddsd.ddckCKSrcBlt.dwColorSpaceLowValue = RGB(0,0,0);	// cerna pruhledna
	hr = lpDD->CreateSurface(&ddsd,&lpSurf, NULL);
	hr = lpSurf->GetDC(&hdc);
	if (hdc) 
	{
		hdcBitmap = CreateCompatibleDC(hdc);
		SelectObject(hdcBitmap,hbmp);
		BitBlt(hdc, 0, 0, info.bmWidth, info.bmHeight,
			hdcBitmap,0,0,SRCCOPY);	// z hdcBitmap do hdc (na surfac)
		DeleteDC(hdcBitmap);
		lpSurf->ReleaseDC(hdc);
	}
	DeleteObject(hbmp);
	return lpSurf;
}


LRESULT CALLBACK ProceduraOkna(
  HWND hwnd,      // handle to window
  UINT uMsg,      // message identifier
  WPARAM wParam,  // first message parameter
  LPARAM lParam   // second message parameter
);

int WINAPI WinMain(
  HINSTANCE hInstance,      // handle to current instance
  HINSTANCE hPrevInstance,  // handle to previous instance
  LPSTR lpCmdLine,          // command line
  int nCmdShow              // show state
)
{
	WNDCLASS wc;
	wc.cbClsExtra =0;
	wc.cbWndExtra = 0;
	wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
	wc.hCursor =LoadCursor(NULL, IDC_ARROW);
	wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
	wc.hInstance = hInstance;
	wc.lpfnWndProc = ProceduraOkna;
	wc.lpszClassName = JMENO_TRIDY_OKNA;
	wc.lpszMenuName = NULL;
	wc.style = CS_OWNDC | CS_HREDRAW | CS_VREDRAW;
	RegisterClass(&wc);
	HWND okno = CreateWindow(JMENO_TRIDY_OKNA
		, "DDraw_test", WS_OVERLAPPEDWINDOW
		, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT
		, NULL,NULL, hInstance,NULL);
	ShowWindow(okno, nCmdShow);
	// done with creation window
	// let's create direct draw instances
	CoInitialize(NULL);	// inicializace COMu
	hr = DirectDrawCreateEx(NULL, (LPVOID*) &lpDD, IID_IDirectDraw7, NULL);
	hr = lpDD->SetCooperativeLevel(okno, DDSCL_FULLSCREEN | DDSCL_EXCLUSIVE);
	hr = lpDD->SetDisplayMode(1024,768,32,60,0);
	DDSURFACEDESC2 ddsd;
	ZeroMemory(&ddsd, sizeof(ddsd));
	ddsd.dwSize = sizeof(ddsd);
	ddsd.dwFlags = DDSD_BACKBUFFERCOUNT | DDSD_CAPS;
	ddsd.dwBackBufferCount = 1;
	ddsd.ddsCaps.dwCaps = DDSCAPS_COMPLEX | DDSCAPS_FLIP | DDSCAPS_PRIMARYSURFACE;
	hr = lpDD->CreateSurface(&ddsd, &lpPrimary, NULL);
	DDSCAPS2 ddscaps;
	ZeroMemory(&ddscaps, sizeof(ddscaps));
	ddscaps.dwCaps = DDSCAPS_BACKBUFFER;
	hr = lpPrimary->GetAttachedSurface(&ddscaps,&lpBack);
	// vycistime surfaces
	DDBLTFX ddbltfx;
	ddbltfx.dwSize = sizeof(ddbltfx);
	ddbltfx.dwFillColor = RGB(255,0,0);
	hr = lpPrimary->Blt(NULL,NULL,NULL, DDBLT_COLORFILL, &ddbltfx);
	hr = lpBack->Blt(NULL, NULL, NULL, DDBLT_COLORFILL, &ddbltfx);
	// nahraju offscreen surface
	lpOffScreen=CreateSurfaceFromBitmap("obrazek.bmp");
	// smycka zprav
	MSG msg;
	int x, y;
	x = 0; y = 0;
	while (1) {
		while (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
		{
			if (msg.message == WM_QUIT) break;
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		if (msg.message== WM_QUIT)break;
		hr = lpBack->Blt(NULL,NULL,NULL, DDBLT_COLORFILL, &ddbltfx);
		HDC hdc;
		lpBack->GetDC(&hdc);
		if (hdc) {
			x++;
			x%=800;
			++y;
			y%= 600;
			Ellipse(hdc, x,y,x+300,y+300);
			lpBack->ReleaseDC(hdc);
		}
		lpBack->BltFast(x,y,lpOffScreen,NULL, DDBLTFAST_SRCCOLORKEY);
		while (1)
		{
			hr = lpPrimary->Flip(NULL, NULL);
			if (hr==DD_OK) break;
			else if (hr==DDERR_SURFACELOST) {
				hr = lpPrimary->Restore();
				if (hr!=DD_OK) break;
			} else if (hr != DDERR_WASSTILLDRAWING) break;
		}
	}
	return (int) msg.wParam;
}

LRESULT CALLBACK ProceduraOkna(
  HWND hwnd,      // handle to window
  UINT uMsg,      // message identifier
  WPARAM wParam,  // first message parameter
  LPARAM lParam   // second message parameter
)
{
	LRESULT rVal=0;
	switch (uMsg)
	{
	case WM_KEYUP:
		switch (wParam) 
		{
		case VK_ESCAPE:
			DestroyWindow(hwnd);
			break;
		default:
			rVal = DefWindowProc(hwnd, uMsg,wParam, lParam);
		}
		break;
	case WM_DESTROY:
		if (lpDD) {
			if (lpPrimary) {
				lpPrimary->Release();
				lpPrimary = NULL;
			}
			lpDD->Release();
			lpDD = NULL;
		}
		PostQuitMessage(0);
		break;
	case WM_PAINT:
		ValidateRect(hwnd, NULL);
		break;
	default:
		rVal = DefWindowProc(hwnd, uMsg, wParam, lParam);
		break;
	}
	return rVal;
}
